from fpylll import*
from operator import xor
import time

def init(a,c,r1,r2,r3,s1,s2,s3,d,nb_output,n):
    m=2**n
    
    #remplissage etat interne
    
    X_0 = ZZ.random_element(0,m-1)
    Y_0 = ZZ.random_element(0,m-1)
    Z_0 = ZZ.random_element(0,m-1)
    X=[X_0]
    Y=[Y_0]
    Z=[Z_0]
    for i in range(1,r1):
        X.append((a*X[-1] +c)%m)
    for i in range(1,r2):
        Y.append((a*Y[-1] +c)%m)
    for i in range(1,r3):  
        Z.append((a*Z[-1] +c)%m)
        
    #PRNG en lui même
    
    w=[]
    for i in range(nb_output):
        xprime = ((X[0] + X[r1-s1])%m) >> d
        yprime = ((Y[0] + Y[r2-s2])%m) >> d
        zprime = ((Z[0] + Z[r3-s3])%m) >> d
        new_x = xor(((X[0] + X[r1-s1])%m),zprime)
        new_y = xor(((Y[0] + Y[r2-s2])%m),xprime)
        new_z = xor(((Z[0] + Z[r3-s3])%m),yprime)
        
        w.append(xor(new_x,new_z))
        X = X[1:] + [new_x]
        Y = Y[1:] + [new_y]
        Z = Z[1:] + [new_z]
    return X_0,Y_0,Z_0,w
    

def f(A,r,s,i):
    """ a passer potentiellement en pre calcul"""
    temp=0
    for j in range(i):
        temp += 2*A[j]
    for j in range(i,r-s+i):
        temp += A[j]
    return temp
    
def g(A,i):
    temp=0
    for j in range(i):
        temp += A[j]    
    return temp
    
def find_Z0(A,c,r1,s1,r3,s3,d,w,n,X0,f2,M):
    """if s3<f :
        return a^(s3)*Z0 % m
    else :
        return (1+a^(r3-s3)*Z0) %m"""

    m=2**n
    list_after = []
    list_before = []

    list_up_Xi = []
    for i in range(min(s1,f2)):
        up_Xi = ((A[i]*(1+A[r1-s1])*X0 + f(A,r1,s1,i)*c)%m) >> (n-d)
        list_up_Xi.append(up_Xi)
        #here we have exact values for up_Xi

    for i in range(s1,f2):
        up_Xi = (((A[i]*X0 + g(A,i)*c)%m + list_up_Xi[i-s1]*2**(n-d))%m) >> (n-d)
        list_up_Xi.append(up_Xi)

    list_up_Zi = []
    for i in range(min(s3,f2)):
        up_wi = w[i] >> (n-d)
        up_Xi = list_up_Xi[i]
        up_Zi = xor(up_Xi,up_wi)
        list_up_Zi.append(up_Zi)
        list_after.append((up_Zi*2**(n-d) - f(A,r3,s3,i)*c)%m)
    
    for i in range(s3,f2):
        up_wi = w[i] >> (n-d)
        up_Zi = xor(list_up_Xi[i],up_wi)
        list_up_Zi.append(up_Zi)
        list_before.append(((up_Zi-list_up_Zi[i-s3])*2**(n-d) - g(A,i)*c)%m)            
    target = tuple(list_before + list_after)
    print(target)
    res = CVP.closest_vector(M,target)
    return(res[0])
 
def find_Y0(A,c,r1,s1,r2,s2,r3,s3,d,w,n,X0,Z0,f1,MY):
    """ to use only if we known Z0
    if s2<f :
        return a^(s2)*Y0 % m
    else :
        return a^(s3)(1+a^(r2-s2)*Y0) %m"""

    m=2**n
    
    list_up_Zi = []
    for i in range(min(s3,f1)):
        up_Zi = ((A[i]*(1+A[r3-s3])*Z0 + f(A,r3,s3,i)*c)%m) >> d
        list_up_Zi.append(up_Zi)
        #here we have exact values for the d first bits of up_Zi
    for i in range(s3,f1):
        up_Zi = ((A[i]*Z0 + g(A,i)*c + list_up_Zi[i-s3]*2**(n-d))%m) >> d
        list_up_Zi.append(up_Zi)
        
    list_down_Xi=[]
    for i in range(min(s1,f1)):
        down_Xi = xor((A[i]*(1+A[r1-s1])*X0 + f(A,r1,s1,i)*c)%2**(n-d),list_up_Zi[i])
        list_down_Xi.append(down_Xi)
        #here the d first bit of down_Xi are exact as long as the up_Zi are exact 
    for i in range(s1,f1):
        down_Xi = xor((A[i]*X0 + g(A,i)*c + list_down_Xi[i-s1])%2**(n-d),list_up_Zi[i])
        list_down_Xi.append(down_Xi)
        
    list_down_Zi=[]
    list_up_Yi=[]
    for i in range(min(s3,f1)):
        down_wi = w[i]%2**(n-d)
        down_Zi = xor(down_wi,list_down_Xi[i])
        list_down_Zi.append(down_Zi)
        up_Yi = xor(down_Zi,(A[i]*(1+A[r3-s3])*Z0 + f(A,r3,s3,i)*c)%2**(n-d))
        list_up_Yi.append(up_Yi)
    for i in range(s3,f1):
        down_wi = w[i]%2**(n-d)
        down_Zi = xor(down_wi,list_down_Xi[i])
        list_down_Zi.append(down_Zi)
        up_Yi = xor(down_Zi,(A[i]*Z0 + g(A,i)*c + list_down_Zi[i-s3])%2**(n-d))
        list_up_Yi.append(up_Yi) 

    list_after=[]
    list_before=[]
    for i in range(min(s2,f1)):
        list_after.append((list_up_Yi[i]*2**(n-d) - f(A,r2,s2,i)*c)%m) 
    for i in range(s2,f1):
        list_before.append(((list_up_Yi[i]-list_up_Yi[i-s2])*2**(n-d) - g(A,i)*c)%m)
    
    target = tuple(list_before + list_after)
    #print(target)
    res = CVP.closest_vector(MY,target)
    res=(res[0])%m
    return res    
    
def find_Y0_alt(A,c,r1,s1,r2,s2,r3,s3,d,w,n,X0,Z0prime,f3,MY,):
    """ to use only if we known (1+A[r3-s3])Z0
    if s2<f :
        return a^(s2)*Y0 % m
    else :
        return a^(s2)(1+a^(r2-s2)*Y0) %m"""

    m=2**n
    
    list_up_Zi = []
    for i in range(f3):
        up_Zi = ((A[i]*Z0prime + f(A,r3,s3,i)*c)%m) >> d
        list_up_Zi.append(up_Zi)
        #here we have exact values for up_Zi

    list_down_Xi=[]
    for i in range(min(s1,f3)):
        down_Xi = xor((A[i]*(1+A[r1-s1])*X0 + f(A,r1,s1,i)*c)%2**(n-d),list_up_Zi[i])
        list_down_Xi.append(down_Xi)
        #here the down_Xi are exact as long as the up_Zi are exact 
    for i in range(s1,f3):
        down_Xi = xor( (A[i]*X0 + g(A,i)*c + list_down_Xi[i-s1])%2**(n-d),list_up_Zi[i])
        list_down_Xi.append(down_Xi)

    list_down_Zi=[]
    list_up_Yi=[]

    for i in range(f3):
        down_wi = w[i]%2**(n-d)
        down_Zi = xor(down_wi,list_down_Xi[i])
        list_down_Zi.append(down_Zi)
        up_Yi = xor(down_Zi,(A[i]*Z0prime + f(A,r3,s3,i)*c)%2**(n-d))
        list_up_Yi.append(up_Yi)

    list_after=[]
    list_before=[]
    for i in range(min(s2,f3)):
        list_after.append((list_up_Yi[i]*2**(n-d) - f(A,r2,s2,i)*c)%m) 
    for i in range(s2,f3):
        list_before.append(((list_up_Yi[i]-list_up_Yi[i-s2])*2**(n-d) - g(A,i)*c)%m)
    
    target = tuple(list_before + list_after)
    res = CVP.closest_vector(MY,target)
    res=(res[0])%m
    return res

def check(a,c,r1,r2,r3,s1,s2,s3,d,w,n,X0,Y0,Z0,nb_output):

    m=2**n
    
    #remplissage etat interne
    X=[X0]
    Y=[Y0]
    Z=[Z0]
    for i in range(1,r1):
        X.append((a*X[-1] +c)%m)
    for i in range(1,r2):
        Y.append((a*Y[-1] +c)%m)
    for i in range(1,r3):  
        Z.append((a*Z[-1] +c)%m)
        
    #PRNG en lui même
    
    wprime=[]
    for i in range(nb_output):
        xprime = ((X[0] + X[r1-s1])%m) >> d
        yprime = ((Y[0] + Y[r2-s2])%m) >> d
        zprime = ((Z[0] + Z[r3-s3])%m) >> d
        new_x = xor(((X[0] + X[r1-s1])%m),zprime)
        new_y = xor(((Y[0] + Y[r2-s2])%m),xprime)
        new_z = xor(((Z[0] + Z[r3-s3])%m),yprime)
        
        wprime.append(xor(new_x,new_z))
        X = X[1:] + [new_x]
        Y = Y[1:] + [new_y]
        Z = Z[1:] + [new_z]
    return w==wprime





def attack(a,c,r1,r2,r3,s1,s2,s3,d,w,n):
    start = time.time()
    m=2^n
    A=[ZZ(pow(a,i,m)) for i in range(max(r1,r2,r3))] #un peu de precalcul
    B2=ZZ(pow(a,-s2,m))
    B3=ZZ(pow(a,-s3,m))
    nb_output = len(w)

    #f = ceil(n/d)
    
    #To retrieve Z0#
    i=0
    while s1+i < ceil(n/(d-i)):
        i=i+1
    f1= ceil(n/(d-i))+1 #we will construct f1 outputs with d-i correct bits


    #To retrieve Y0#
    i=0
    while s3+i < ceil(n/(d-i)):
        i=i+1
    f3= ceil(n/(d-i))+1 #we will construct f3 outputs with d-i correct bits




    #the attack(4 cases)#
    if s3<f1 and s2<f3: #cas facile
   
        print('cas1')

        t = f1-s3
        MZ = matrix(f1,f1)
        for j in range(0,t):
            MZ[j,j] = m
            MZ[0,j] = A[j]
        for j in range(s3):
            MZ[0,t+j] = (A[j]*(1+A[r3-s3]))*B3 %m
            MZ[t+j,t+j] = m    
        MZ=MZ.LLL()
        MZ=IntegerMatrix.from_matrix(MZ)

        t = max(f3-s2,0)
        MY = matrix(f3,f3)
        for j in range(0,t):
            MY[j,j] = m
            MY[0,j] = A[j]
        for j in range(s2):
            MY[0,t+j] = (A[j]*(1+A[r2-s2]))*B2 %m
            MY[t+j,t+j] = m    
        MY=MY.LLL()
        MY=IntegerMatrix.from_matrix(MY)

        for X0 in [12973747913725252780]:#range(2**n):
            Z0 = (find_Z0(A,c,r1,s1,r3,s3,d,w,n,X0,f1,MZ)*B3)%m
            print(Z0)
            Y0 = (find_Y0(A,c,r1,s1,r2,s2,r3,s3,d,w,n,X0,Z0,f3,MY)*B2)%m
            if check(a,c,r1,r2,r3,s1,s2,s3,d,w,n,X0,Y0,Z0,nb_output):
                print('okay')
                return X0,Y0,Z0
        
    elif s3<f1 and s2>=f3:

        print('cas2')

        t = max(f1-s3,0)
        MZ = matrix(f1,f1)
        for j in range(0,t):
            MZ[j,j] = m
            MZ[0,j] = A[j]
        for j in range(s3):
            MZ[0,t+j] = (A[j]*(1+A[r3-s3]))*B3 %m
            MZ[t+j,t+j] = m    
        MZ=MZ.LLL()
        MZ=IntegerMatrix.from_matrix(MZ)

        MY = matrix(f3,f3)
        for j in range(0,f3):
            MY[j,j] = m
            MY[0,j] = A[j]
        MY=MY.LLL()
        MY=IntegerMatrix.from_matrix(MY)

        for X0 in [12973747913725252780]:#range(2**n):
            Z0 = (find_Z0(A,c,r1,s1,r3,s3,d,w,n,X0,f1,MZ)*B3)%m
            Y0prime = (find_Y0(A,c,r1,s1,r2,s2,r3,s3,d,w,n,X0,Z0,f3,MY)) %m
            X = [X0]
            for i in range(1,r1):
                X.append((a*X[-1]+c)%m)
            Z = [Z0]
            for i in range(1,r3):
                Z.append((a*Z[-1]+c)%m)
            V2 = gcd(1+A[r2-s2],m)
            v2=log(V2,2)
            if v2 < d :   
                rY0 = ZZ(((Y0prime//V2)*pow((1+A[r2-s2])//V2,-1,m))%2**(n-v2))
                #Y0 = b*2**(n-v2) + rY0 and we want to find b
                Y_r2 = xor((Y0prime + f(A,r2,s2,0)*c)%m,(((1+A[r1-s1])*X0 + f(A,r1,s1,0)*c)%m)>>d)
                for i in range(s2):
                    X_temp = (X[-s1]+X[-r1]) %m
                    Z_temp = (Z[-s3]+Z[-r3]) %m
                    up_Yi = ((A[i]*Y0prime + f(A,r2,s2,i)*c)%m) >> d
                    new_X = xor(X_temp,Z_temp >> d)
                    new_Z = xor(Z_temp, up_Yi)
                    X = X[1:]+[new_X]
                    Z = Z[1:]+[new_Z]
                Z_temp = (Z[-s3]+Z[-r3]) %m
                up_Y_r2_s2 = xor(xor((X[-s1]+X[-r1]) %2**(n-d),Z_temp>>d),xor(Z_temp %2**(n-d),w[s2]%2**(n-d)))
                j = up_Y_r2_s2 >>(d-v2)
                k = ((A[s2]*rY0+g(A,s2)*c+Y_r2)%m)>>(n-v2)
                b = ((j-k)*B2) %m
                Y0 = (b*2**(n-v2)+rY0) %m
                if check(a,c,r1,r2,r3,s1,s2,s3,d,w,n,X0,Y0,Z0,nb_output):
                    print('okay')
                    return X0,Y0,Z0 

    elif s3>=f1 and s2<f3:
        print('cas3')

        MZ = matrix(f1,f1)
        for j in range(0,f1):
            MZ[j,j] = -1
            MZ[0,j] = A[j]
        MZ[0,0]=m
        MZ=MZ.transpose()
        MZ=MZ.LLL()
        MZ=IntegerMatrix.from_matrix(MZ)

        t = max(f3-s2,0)
        MY = matrix(f3,f3)
        for j in range(0,t):
            MY[j,j] = m
            MY[0,j] = A[j]
        for j in range(s2):
            MY[0,t+j] = (A[j]*(1+A[r2-s2]))*B2 %m
            MY[t+j,t+j] = m    
        MY=MY.LLL()
        MY=IntegerMatrix.from_matrix(MY)

        for X0 in [12973747913725252780]:#range(2**n):
            Z0prime = find_Z0(A,c,r1,s1,r3,s3,d,w,n,X0,f1,MZ) %m
            Y0 = find_Y0_alt(A,c,r1,s1,r2,s2,r3,s3,d,w,n,X0,Z0prime,f3,MY)*B2 %m
            print(Y0)

            X = [X0]
            for i in range(1,r1):
                X.append((a*X[-1]+c)%m)
            Y = [Y0]
            for i in range(1,r2):
                Y.append((a*Y[-1]+c)%m)
            V2= gcd(1+A[r3-s3],m)
            v2=log(V2,2)
            if v2 < d :   
                rZ0 = ZZ(((Z0prime//V2)*pow((1+A[r3-s3])//V2,-1,m))%2**(n-v2))
                #Z0 = b*2**(n-v2) + rZ0 and we want to find b
                Z_r3 = xor((Z0prime + f(A,r3,s3,0)*c)%m,(((1+A[r2-s2])*Y0 + f(A,r2,s2,0)*c)%m)>>d)
                for i in range(s3):
                    X_temp = (X[-s1]+X[-r1]) %m
                    Y_temp = (Y[-s2]+Y[-r2]) %m
                    up_Zi = ((A[i]*Z0prime + f(A,r3,s3,i)*c)%m) >> d
                    new_X = xor(X_temp,up_Zi)
                    new_Y = xor(Y_temp,X_temp >> d)
                    X = X[1:]+[new_X]
                    Y = Y[1:]+[new_Y]
                X_temp = (X[-s1]+X[-r1]) %m
                up_Z_r3_s3 = xor(w[s3] >> d,X_temp >>d)
                j = up_Z_r3_s3 >>(d-v2)
                k = ((A[s3]*rZ0+g(A,s3)*c+Z_r3)%m)>>(n-v2)
                b = ((j-k)*B3) %m
                Z0 = (b*2**(n-v2)+rZ0)%m
                if check(a,c,r1,r2,r3,s1,s2,s3,d,w,n,X0,Y0,Z0,nb_output):
                    print('okay')
                    return X0,Y0,Z0 

    else :

        MZ = matrix(f1,f1)
        for j in range(0,f1):
            MZ[j,j] = m
            MZ[0,j] = A[j] 
        MZ=MZ.LLL()
        MZ=IntegerMatrix.from_matrix(MZ)

        MY = matrix(f3,f3)
        for j in range(0,f3):
            MY[j,j] = m
            MY[0,j] = A[j] 
        MY=MY.LLL()
        MY=IntegerMatrix.from_matrix(MY)  

        if s2<s3:
            print('cas4')
            for X0 in [12973747913725252780]:#range(2**n):
                Z0prime = (find_Z0(A,c,r1,s1,r3,s3,d,w,n,X0,f1,MZ))%m
                Y0prime = find_Y0_alt(A,c,r1,s1,r2,s2,r3,s3,d,w,n,X0,Z0prime,f3,MY) %m                
                # we start by deriving Y0
                X = [X0]
                for i in range(1,r1):
                    X.append((a*X[-1]+c)%m)
                V2 = gcd(1+A[r2-s2],m)
                v2=log(V2,2)
                if v2 < d :   
                    rY0 = ZZ(((Y0prime//V2)*pow((1+A[r2-s2])//V2,-1,m))%2**(n-v2))
                    #Y0 = b*2**(n-v2) + rY0 and we want to find b
                    Yi_r2 = xor((Y0prime + f(A,r2,s2,0)*c)%m,(((1+A[r1-s1])*X0 + f(A,r1,s1,0)*c)%m)>>d)
                    for i in range(s2):
                        X_temp = (X[-s1]+X[-r1]) %m
                        Z_temp = (A[i]*Z0prime + f(A,r3,s3,i)*c) %m #because s2<s3
                        up_Yi = ((A[i]*Y0prime + f(A,r2,s2,i)*c)%m) >> d
                        new_X = xor(X_temp,Z_temp >> d)
                        X = X[1:]+[new_X]
                    Z_temp = (A[s2]*Z0prime + f(A,r3,s3,s2)*c)%m
                    up_Yi_r2_s2 = xor(xor((X[-s1]+X[-r1]) %2**(n-d),Z_temp>>d),xor(Z_temp %2**(n-d),w[s2]%2**(n-d)))
                    j = up_Yi_r2_s2 >>(d-v2)
                    k = ((A[s2]*rY0+g(A,s2)*c+Yi_r2)%m)>>(n-v2)
                    b = ((j-k)*B2) %m
                    Y0 = (b*2**(n-v2)+rY0)%m

                    #now we derive Z0
                    X = [X0]
                    for i in range(1,r1):
                        X.append((a*X[-1]+c)%m)
                    Y = [Y0]
                    for i in range(1,r2):
                        Y.append((a*Y[-1]+c)%m)
                    V2 = gcd(1+A[r3-s3],m)
                    v2=log(V2,2)
                    if v2 < d :   
                        rZ0 = ZZ(((Z0prime//V2)*pow((1+A[r3-s3])//V2,-1,m))%2**(n-v2))
                        #Z0 = b*2**(n-v2) + rZ0 and we want to find b
                        Zi_r3 = xor((Z0prime + f(A,r3,s3,0)*c)%m,(((1+A[r2-s2])*Y0 + f(A,r2,s2,0)*c)%m)>>d)
                        for i in range(s3):
                            X_temp = (X[-s1]+X[-r1]) %m
                            Y_temp = (Y[-s2]+Y[-r2]) %m
                            up_Zi = ((A[i]*Z0prime + f(A,r3,s3,i)*c)%m) >> d
                            new_X = xor(X_temp,up_Zi)
                            new_Y = xor(Y_temp,X_temp >> d)
                            X = X[1:]+[new_X]
                            Y = Y[1:]+[new_Y]
                        X_temp = (X[-s1]+X[-r1]) %m
                        up_Zi_r3_s3 = xor(w[s3] >> d,X_temp >>d)
                        j = (up_Zi_r3_s3) >>(d-v2)
                        k = ((A[s3]*rZ0+g(A,s3)*c+Zi_r3)%m)>>(n-v2)
                        b = ((j-k)*B3) %m
                        Z0 = (b*2**(n-v2)+rZ0)%m      
                        if check(a,c,r1,r2,r3,s1,s2,s3,d,w,n,X0,Y0,Z0,nb_output):
                            print('okay')
                            return X0,Y0,Z0                
                    
                    
                    
        elif s3<=s2:
            print('cas5')
            for X0 in [12973747913725252780]:#range(2**n):
                Z0prime = (find_Z0(A,c,r1,s1,r3,s3,d,w,n,X0,f1,MZ))%m
                Y0prime = find_Y0_alt(A,c,r1,s1,r2,s2,r3,s3,d,w,n,X0,Z0prime,f3,MY)%m
                #we derive Z0
                X = [X0]
                for i in range(1,r1):
                    X.append((a*X[-1]+c)%m)
                v2 = gcd(1+A[r3-s3],m)
                if v2 < d :   
                    rZ0 = ZZ(((Z0prime//v2)*pow((1+A[r3-s3])//v2,-1,m))%2**(n-v2))
                    #Z0 = b*2**(n-v2) + rZ0 and we want to find b
                    Zi_r3 = xor((Z0prime + f(A,r3,s3,0)*c)%m,((Y0prime + f(A,r2,s2,0)*c)%m)>>d)
                    for i in range(s3):
                        X_temp = (X[-s1]+X[-r1]) %m
                        #Y_temp = (A[i]*Y0prime + f(A,r2,s2,i)*c) %m
                        up_Zi = ((A[i]*Z0prime + f(A,r3,s3,i)*c)%m) >> d
                        new_X = xor(X_temp,up_Zi)
                        #new_Y = xor(Y_temp,(X_temp >> d))
                        X = X[1:]+[new_X]
                    X_temp = (X[-s1]+X[-r1]) %m
                    up_Zi_r3_s3 = xor(w[s3] >> d,X_temp >>d)
                    j = up_Zi_r3_s3 >>(d-v2)
                    k = ((A[s3]*rZ0+g(A,s3)*c+Zi_r3)%m)>>(n-v2)
                    b = ((j-k)*B3) %m
                    Z0 = (b*2**(n-v2)+rZ0)%m

                
                    # now we derive Y0
                    X = [X0]
                    for i in range(1,r1):
                        X.append((a*X[-1]+c)%m)
                    Z = [Z0]
                    for i in range(1,r3):
                        Z.append((a*Z[-1]+c)%m)
                    v2 = gcd(1+A[r2-s2],m)
                    if v2 < d :   
                        rY0 = ZZ(((Y0prime//v2)*pow((1+A[r2-s2])//2,-1,m))%2**(n-v2))
                        #Y0 = b*2**(n-v2) + rY0 and we want to find b
                        Yi_r2 = xor((Y0prime + f(A,r2,s2,0)*c)%m,(((1+A[r1-s1])*X0 + f(A,r1,s1,0)*c)%m)>>d)
                        for i in range(s2):
                            X_temp = (X[-s1]+X[-r1]) %m
                            Z_temp = (Z[-s3]+Z[-r3]) %m
                            up_Yi = ((A[i]*Y0prime + f(A,r2,s2,i)*c)%m) >> d
                            new_X = xor(X_temp,Z_temp >> d)
                            new_Z = xor(Z_temp, up_Yi)
                            X = X[1:]+[new_X]
                            Z = Z[1:]+[new_Z]
                        Z_temp = (Z[-s3]+Z[-r3]) %m
                        up_Yi_r2_s2 = xor(xor((X[-s1]+X[-r1]) %2**(n-d),Z_temp>>d),xor(Z_temp %2**(n-d),w[s2]%2**(n-d)))
                        j = up_Yi_r2_s2 >>(d-v2)
                        k = ((A[s2]*rY0+g(A,s2)*c+Yi_r2)%m)>>(n-v2)
                        b = ((j-k)*B2) %m
                        Y0 = (b*2**(n-v2)+rY0)%m
                        if check(a,c,r1,r2,r3,s1,s2,s3,d,w,n,X0,Y0,Z0,nb_output):
                            print('okay')
                            print(time.time()-start)
                            return X0,Y0,Z0

    print(time.time()-start)

